#include <iostream>

using namespace std;

int** create_matrix(int rows, int cols){ // создание матрицы
    int **matrix = new int *[rows]; // создание массива matrix с размером rows
	for (int i = 0; i < rows; i++){ // цикл от 0 до rows
		matrix[i] = new int [cols]; // создание массива с размером cols в текущем элементе
	}
    return matrix; // возвращение созданной матрицы
}

void input_matrix_elements(int **matrix, int rows, int cols){ // ввод элементов матрицы
    cout << endl << "Input elements of matrix: " << endl;
    for (int i = 0; i < rows; i++){
		for (int j = 0; j < cols; j++){
            cin >> matrix[i][j];
        }
		cout << endl;
	}
}

void output_matrix(int **matrix, int rows, int cols){ // вывод элментов матрицы
    for (int i = 0; i < rows; i++){
		for (int j = 0; j < cols; j++){
            cout << matrix[i][j] << "\t";
        }
		cout << endl;
	}
}

int elements_counting(int **matrix, int rows, int cols){ // подсчёт суммы элементов
	int sum = 0; // создание переменной sum
	// цикл на прохождение матрицы
	for (int i = 0; i < rows; i++){
		for (int j = i + 1; j < cols; j++){
			sum += matrix[i][j]; 
        }
	}

	return sum;
}

void delete_matrix(int **matrix, int iterations){ // удаление матрицы
    for (int i = 0; i < iterations; i++){ // цикл от 0 до iterations
        delete[] matrix[i]; // удаление текущего элемента матрицы
    }
    delete[] matrix; // удаление матрицы
}

int main(){
	int rows, cols; // строки и столбцы матрицы
	int sum; // переменная суммы

	// ввод размера матрицы 
	cout << "Input rows of matrix: " << endl;
	cin >> rows;

	cout << "Input cols of matrix: " << endl;
	cin >> cols;
	
	// если размер меньше 0, то завершаем программу
	if ((rows < 1) || (cols < 1)){
		cout << "Size cannot be less than 1." << endl; 
		return 0;
	}

	// инициализация матрицы с указанными размерами
    int **matrix = create_matrix(rows, cols);

	// ввод матрицы
	input_matrix_elements(matrix, rows, cols);

	// вывод матрицы
	cout << "Entered matrix: " << endl;
	output_matrix(matrix, rows, cols);
	
	// если количество столбцов меншье 2, то значит, что слагаемых для посчёта нет
	if (cols < 2){
		cout << endl << "There are no summands." << endl;
		delete_matrix(matrix, rows);
		return 0;
	}

	// подсчёт элементов
	sum = elements_counting(matrix, rows, cols);
	
	// вывод
    cout << endl << "Sum of elements above the main diagonal: " << sum << endl;

    // очистка ОЗУ
    delete_matrix(matrix, rows);
	
	return 0;
}
